#ifndef _MOVE_STRUCT_H
#define _MOVE_STRUCT_H

#include <stdint.h>

/// Structure for holding movement data
typedef struct
{
	uint8_t master_dir_pin;
	uint8_t master_step_pin;
	uint32_t master_pulse_width;
	uint8_t master_dir; 
	uint32_t master_start_stop_speed;
	uint32_t master_total_steps;
	uint32_t master_ramp_up_steps;
	uint32_t master_running_steps;
	uint32_t master_ramp_down_steps;
	uint32_t master_ramp_inc_dec;
	char master_axis[1];

	uint8_t follower_1_dir_pin;
	uint8_t follower_1_step_pin;
	uint32_t follower_1_pulse_width;
	uint8_t follower_1_dir;
	uint32_t follower_1_total_steps;
	double follower_1_ratio; 
	double follower_1_int_part;
	double follower_1_dec_part;
	char follower_1_axis[1];

	uint8_t follower_2_dir_pin;
	uint8_t follower_2_step_pin;
	uint32_t follower_2_pulse_width;
	uint8_t follower_2_dir;
	uint32_t follower_2_total_steps;
	double follower_2_ratio; 
	double follower_2_int_part;
	double follower_2_dec_part;
	char follower_2_axis[1];

	uint8_t follower_3_dir_pin;
	uint8_t follower_3_step_pin;
	uint32_t follower_3_pulse_width;
	uint8_t follower_3_dir;
	uint32_t follower_3_total_steps;
	double follower_3_ratio; 
	double follower_3_int_part;
	double follower_3_dec_part;
	char follower_3_axis[1];

} MOVE_STRUCT;

// Structure for holding the current movement data.
extern MOVE_STRUCT current_move;

#endif /* _MOVE_STRUCT_H */